/*
 * Semantic Similarity API
 *
 * This API computes the simlarity of RDF entities
 *
 * The version of the OpenAPI document: 0.0.1
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.SemanticSimilarity.Core.Client.OpenAPIDateConverter;

namespace Coscine.SemanticSimilarity.Core.Model
{
    /// <summary>
    /// SimilarityReturnOutput
    /// </summary>
    [DataContract(Name = "SimilarityReturnOutput")]
    public partial class SimilarityReturnOutput : IEquatable<SimilarityReturnOutput>, IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="SimilarityReturnOutput" /> class.
        /// </summary>
        /// <param name="similarityMatrix">similarityMatrix.</param>
        /// <param name="timeSpent">timeSpent.</param>
        public SimilarityReturnOutput(SimilarityMatrix similarityMatrix = default(SimilarityMatrix), decimal timeSpent = default(decimal))
        {
            this.SimilarityMatrix = similarityMatrix;
            this.TimeSpent = timeSpent;
        }

        /// <summary>
        /// Gets or Sets SimilarityMatrix
        /// </summary>
        [DataMember(Name = "similarity_matrix", EmitDefaultValue = false)]
        public SimilarityMatrix SimilarityMatrix { get; set; }

        /// <summary>
        /// Gets or Sets TimeSpent
        /// </summary>
        [DataMember(Name = "time_spent", EmitDefaultValue = false)]
        public decimal TimeSpent { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class SimilarityReturnOutput {\n");
            sb.Append("  SimilarityMatrix: ").Append(SimilarityMatrix).Append("\n");
            sb.Append("  TimeSpent: ").Append(TimeSpent).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// Returns true if objects are equal
        /// </summary>
        /// <param name="input">Object to be compared</param>
        /// <returns>Boolean</returns>
        public override bool Equals(object input)
        {
            return this.Equals(input as SimilarityReturnOutput);
        }

        /// <summary>
        /// Returns true if SimilarityReturnOutput instances are equal
        /// </summary>
        /// <param name="input">Instance of SimilarityReturnOutput to be compared</param>
        /// <returns>Boolean</returns>
        public bool Equals(SimilarityReturnOutput input)
        {
            if (input == null)
            {
                return false;
            }
            return 
                (
                    this.SimilarityMatrix == input.SimilarityMatrix ||
                    (this.SimilarityMatrix != null &&
                    this.SimilarityMatrix.Equals(input.SimilarityMatrix))
                ) && 
                (
                    this.TimeSpent == input.TimeSpent ||
                    this.TimeSpent.Equals(input.TimeSpent)
                );
        }

        /// <summary>
        /// Gets the hash code
        /// </summary>
        /// <returns>Hash code</returns>
        public override int GetHashCode()
        {
            unchecked // Overflow is fine, just wrap
            {
                int hashCode = 41;
                if (this.SimilarityMatrix != null)
                {
                    hashCode = (hashCode * 59) + this.SimilarityMatrix.GetHashCode();
                }
                hashCode = (hashCode * 59) + this.TimeSpent.GetHashCode();
                return hashCode;
            }
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<System.ComponentModel.DataAnnotations.ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            yield break;
        }
    }

}
